// PocketIrked2Doc.cpp : implementation of the CPocketIrked2Doc class
//

#include "stdafx.h"
#include "PocketIrked2.h"
#include "PocketIrked2Doc.h"
#include "basiclevels.h"

#define HINIBBLE(b)   ((BYTE) (((BYTE) (b) >> 4) & 0x0F)) 
#define LONIBBLE(b)   ((BYTE) (((BYTE) (b)) & 0x0F)) 
#define LINELEN (180)

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPocketIrked2Doc

IMPLEMENT_DYNCREATE(CPocketIrked2Doc, CDocument)

BEGIN_MESSAGE_MAP(CPocketIrked2Doc, CDocument)
	//{{AFX_MSG_MAP(CPocketIrked2Doc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPocketIrked2Doc construction/destruction

CLevel::CLevel()
{
	m_strTitle.Empty();
	m_btSolution[0]=NULL;
}

void CLevel::operator =(CLevel& that)
{
	int i,j;
	
	for(i=0;i<10;i++)
		for(j=0;j<8;j++)
			m_lBits[j][i]=that.m_lBits[j][i];
	m_strTitle = that.m_strTitle;;
	
	strcpy((char*)m_btSolution,(char*)(that.m_btSolution));
}

CPocketIrked2Doc::CPocketIrked2Doc()
{
	CPocketIrked2App *pApp=(CPocketIrked2App*)AfxGetApp();

	m_llUndoStack.RemoveAll();

	/***
	load persistants
	[global]
	pack=

    [pack]
	maxlevel=
	***/
	
	m_strPack=pApp->GetProfileString(CString("global"),CString("pack"),CString("Classic Levels.lvl"));
	m_iTileset=pApp->GetProfileInt(_T("global"),_T("tileset"),1000);
	m_iMaxLevel=pApp->GetProfileInt(m_strPack,CString("maxlevel"),0);
	m_iLevelScore=pApp->GetProfileInt(m_strPack,CString("score"),0);
	LoadLevels(m_strPack);
	PlayLevel(m_iMaxLevel);
}

CPocketIrked2Doc::~CPocketIrked2Doc()
{
	int i,j;

	// clean them out
	i= m_mwpLevels.GetCount();
	for(j=0;j<i;j++)
	{
		CLevel *pLevel;
		m_mwpLevels.Lookup(j,(void*&)pLevel);
		delete pLevel;
	}
	m_mwpLevels.RemoveAll();
}

BOOL CPocketIrked2Doc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CPocketIrked2Doc serialization

void CPocketIrked2Doc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CPocketIrked2Doc diagnostics

#ifdef _DEBUG
void CPocketIrked2Doc::AssertValid() const
{
	CDocument::AssertValid();
}

void CPocketIrked2Doc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPocketIrked2Doc commands

BOOL CPocketIrked2Doc::Push()
{
	CLevel *pLevel = new CLevel();

	(*pLevel)=m_lPlayGround;
	m_llUndoStack.AddHead(pLevel);
	if(m_llUndoStack.GetCount() > 15)
		m_llUndoStack.RemoveTail();

	return FALSE;
}

BOOL CPocketIrked2Doc::Pop()
{
	CLevel *pLevel;
	if(m_llUndoStack.GetCount())
	{
		pLevel = m_llUndoStack.RemoveHead();
		m_lPlayGround = (*pLevel);
		delete pLevel;
	}

	return FALSE;
}

BOOL CPocketIrked2Doc::Memorize()
{
	m_bMemory=TRUE;
	m_lMemory=m_lPlayGround;
	return TRUE;
}

BOOL CPocketIrked2Doc::Recall()
{
	if(m_bMemory)
		m_lPlayGround=m_lMemory;
	return m_bMemory;
}


int CPocketIrked2Doc::LoadLevels(LPCTSTR strFilename) // if the fname is empty then you should load the basic levels from memeory
{
	int i,j,k;
	CHAR *noteof;

	// clean them out
	i= m_mwpLevels.GetCount();
	for(j=0;j<i;j++)
	{
		CLevel *pLevel;
		m_mwpLevels.Lookup(j,(void*&)pLevel);
		delete pLevel;
	}
	m_mwpLevels.RemoveAll();

	// load from file
	if(wcscmp(strFilename,_T("pocketirked2builtin")))
	{
		FILE *f;
		char line[LINELEN];

		if(f=_wfopen(CString("\\My Documents\\Irked2 Levels\\")+strFilename,_T("r")))
		{
			k=0;
			noteof=fgets(line,LINELEN,f);
			while(noteof)
			{		
				if(line[0] == '[') 
				{ // found the beginning of a section
					//is it a general or a level?

					if(!_strnicmp(line,"[general]",9))
					{
						do
						{
							if(!fgets(line,LINELEN,f))
								break;
							if(line[0] != '[')
							{
								char *tok;

								// in here we look for
								// Author=
								// URL=
								// Description=
								
								tok=strtok(line,"=\r\n");
								if(tok && !_stricmp(tok,"author"))
								{
									//char *author;
									m_strAuthor=strtok(NULL,"\r\n");
									//printf("author: %s\n",author);
								}
								else if(tok && !_stricmp(tok,"url"))
								{
									//char *url;
									m_strURL=strtok(NULL,"\r\n");
									//printf("url: %s\n",url);
								}
								else if(tok && !_stricmp(tok,"description"))
								{
									char *description;
									description=strtok(NULL,"\r\n");
									m_strDescription=description;
									//printf("description: %s\n",description);
								}
							}
						}while(line[0] != '[');
					}
					
					if(!_strnicmp(line,"[level]",7))
					{
						CLevel *pLevel = new CLevel();
						m_mwpLevels.SetAt(k,pLevel);

						do
						{
							if(!fgets(line,LINELEN,f))
								break;
							if(line[0] != '[')
							{
								char *tok;

								// board
								// solution
								// title

								tok=strtok(line,"=\r\n");
								if(tok && !_stricmp(tok,"board"))
								{
									char *board;
									board=strtok(NULL,"\r\n");
									ParseLevelNotation(board, pLevel);
									//printf("board: %s\n",board);
								}
								else if(tok && !_stricmp(tok,"solution"))
								{
									char *solution;
									solution=strtok(NULL,"\r\n");
									strcpy((char*)pLevel->m_btSolution,solution);
									//printf("solution: %s\n",solution);
								}
								else if(tok && !_stricmp(tok,"title"))
								{
									char *title;
									title=strtok(NULL,"\r\n");
 									pLevel->m_strTitle=CString(title);
									//printf("title: %s\n",title);
								}
							}
						}while(line[0] != '[');
						
						k++;
					}
				}
				else
				{
					noteof=fgets(line,LINELEN,f);
				}
			}
			fclose(f);
			m_iMaxPackLevel=m_mwpLevels.GetCount()-1;
			return 0;

		}
		else
		{  // pack was not found, load the builtins
			m_strPack="pocketirked2builtin";
		}

	}
/**/
	for(k=0;k<118;k++)
	{
		CLevel *pLevel = new CLevel();
		m_mwpLevels.SetAt(k,pLevel);
		
		if(k < 59)
			pLevel->m_strTitle.Format(TEXT("Classic: Level %d"),k);
		else
			pLevel->m_strTitle.Format(TEXT("Classic II: Level %d"),k-59);
		pLevel->m_btSolution[0]=0;

		m_strAuthor=TEXT("James McCombe && Steve Haynal");
		m_strURL.Empty();
		m_strDescription=TEXT("Built in Levels");


		for(j=0;j<8;j++)
			for(i=0;i<10;i+=2)
			{
				pLevel->m_lBits[j][i]=HINIBBLE(lBasicLevels[k][j][i/2]);
				pLevel->m_lBits[j][i+1]=LONIBBLE(lBasicLevels[k][j][i/2]);
			}
	}
/**/
	m_iMaxPackLevel=m_mwpLevels.GetCount()-1;
	
	return 0;
}

int CPocketIrked2Doc::PlayLevel(int iLevel)
{
	int i,j;
	CLevel *pLevel=NULL;

	m_bMemory=FALSE; // gets reset when we reload or advance
	while(m_llUndoStack.GetCount())
	{
		delete m_llUndoStack.RemoveHead();
	}

	if(iLevel >=0 && iLevel <= m_mwpLevels.GetCount())
	{
		m_mwpLevels.Lookup(iLevel,(void *&)pLevel);

		if(pLevel)
		{
			m_iCurrentLevel=iLevel;
			m_lPlayGround.m_strTitle=pLevel->m_strTitle;
			strcpy((char*)m_lPlayGround.m_btSolution,(char*)pLevel->m_btSolution);
			for(i=0;i<10;i++)
				for(j=0;j<8;j++)
					m_lPlayGround.m_lBits[j][i]=pLevel->m_lBits[j][i];
			
			if(AfxGetApp()->m_pMainWnd)
			{
				CString strTitle;
				strTitle.Format(_T("%d: %s"),m_iCurrentLevel,pLevel->m_strTitle);
				AfxGetApp()->m_pMainWnd->SetWindowText(strTitle);
			}
		}
	}
	return 0;
}


BOOL CPocketIrked2Doc::ParseLevelNotation(char *pszLevel, CLevel *pLevel)
{
   BYTE level[8][10];
   BYTE *pbLoad;
   int i,j;
   
   // Validate the board and get the dimensions

	char *pszLast = pszLevel;
	BOOL fLoop = TRUE;
	int cRows = 0;
	int cCols = -1;
	while (fLoop) 
	{
      int cColsT;
		char *pszNext = strchr(pszLast, '/');
		if (pszNext == NULL) 
		{
			pszNext = pszLast + strlen(pszLast);
			fLoop = FALSE;
		}
		cColsT = LoadLevelRow(NULL, pszLast, pszNext);
		if (cCols == -1) 
		{
			cCols = cColsT;
		} 
		else if (cCols != cColsT) 
		{
			return FALSE;
		}
		cRows++;
		pszLast = pszNext + 1;
	}

	// Vexed wants these sizes

	if (cCols != 10 || cRows != 8)
		return FALSE;

	// Load it this time

	pbLoad = &level[0][0];
	pszLast = pszLevel;
	fLoop = TRUE;
	while (fLoop) 
	{
		// Find the end of this row

		char *pszNext = strchr(pszLast, '/');
		if (pszNext == NULL) 
		{
			pszNext = pszLast + strlen(pszLast);
			fLoop = FALSE;
		}

		// Load the row

		LoadLevelRow(pbLoad, pszLast, pszNext);

		// Next row...

		pbLoad += 10;
		pszLast = pszNext + 1;
	}

   // Convert into *pLevel format

	for(i=0;i<10;i++)
	{
		for(j=0;j<8;j++)
		{
			pLevel->m_lBits[j][i]=level[j][i];
		}
	}

   return TRUE;
}

int CPocketIrked2Doc::LoadLevelRow(byte *pb, char *psz, char *pszMax)
{
	int cBlocks = 0;
	for (; psz < pszMax; psz++) 
	{
		char ch = *psz;

		// Is this a number (non-moveable blocks?)
		
		int c = 0;
		while (ch >= '0' && ch <= '9') 
		{
			c = c * 10 + ch - '0';
			psz++;
			if (psz >= pszMax)
				break;
			ch = *psz;
		}
		if (c != 0) 
		{
			cBlocks += c;
			if (pb != NULL) 
			{
				while (c != 0) 
				{
					*pb++ = 9;
					c--;
				}
			}
			psz--;
			continue;
		}

		// Is this empty space?

		if (ch == '~') 
		{
			cBlocks++;
			if (pb != NULL)
				*pb++ = 0;
			continue;
		}

		// This is a block type. Remember it verbatim

      if (ch < 'a' || ch > 'h')
         return -1;

		cBlocks++;
		if (pb != NULL)
			*pb++ = ch - 'a' + 1;
	}

	return cBlocks;
}
